﻿-- Author      : kevin.ortman
-- Create Date : 12/28/2008 1:49:12 PM


GuildWork.CommPrefix = "GuildWork"
GuildWork.OnGuildCommReceive = {}
GuildWork.UpdatingRoster = false

function GuildWork:RegisterCommunication()
    self:RegisterComm(self.CommPrefix, "GUILD", "OnGuildCommReceive")
    self:SetCommPrefix(GuildWork.CommPrefix)
    
    self:RegisterMemoizations { "ROSTER" }
    
    self:AnnounceRoster()
end

function GuildWork:AnnounceRoster()
	for profileName, profile in pairs(GuildWork:GetRoster()) do
		self:SendCommMessage("GUILD", "ROSTER", profileName, profile.lastupdate, profile.wish[1], profile.wish[2], profile.wish[3], profile.wish[4], profile.wish[5])
	end		
end

function GuildWork:AnnounceProfile(profileNameToAnnounce)
	for profileName, profile in pairs(GuildWork:GetRoster()) do
		if (profileName == profileNameToAnnounce) then
			self:SendCommMessage("GUILD", "ROSTER", profileName, profile.lastupdate, profile.wish[1], profile.wish[2], profile.wish[3], profile.wish[4], profile.wish[5])
		end
	end		
end

function GuildWork.OnGuildCommReceive:ROSTER(prefix, sender, distribution, sentProfile, sentLastupdate, wish1, wish2, wish3, wish4, wish5)
    if(not sentProfile) or (sentProfile ~= UnitName("player")) then
		local foundProfileLastUpdate
	    
   		for profileName, profile in pairs(GuildWork:GetRoster()) do
   			if(profileName == sentProfile) then
   				foundProfileLastUpdate = profile.lastupdate 
   			end
		end
		
		if not foundProfileLastUpdate then
			foundProfileLastUpdate = date("!*t")
			foundProfileLastUpdate.year = 2000
		end
		
		if(time(sentLastupdate) < time(foundProfileLastUpdate)) then
			GuildWork:AnnounceProfile(sentProfile)
		else
			if(time(sentLastupdate) > time(foundProfileLastUpdate)) then
				GuildWork:SetProfileData(sentProfile, sentLastupdate, wish1, wish2, wish3, wish4, wish5)
			end
		end
    end 

end



