﻿-- Author      : kevin.ortman
-- Create Date : 12/28/2008 1:35:23 PM

GuildWork:RegisterDB("GuildWorkDB", "GuildWorkDBPerChar")
GuildWork:RegisterDefaults("char", 
	{
		lastupdate = 
		{
			["hour"] = 1,
			["min"] = 1,
			["wday"] = 1,
			["day"] = 1,
			["month"] = 1,
			["year"] = 2000,
			["sec"] = 1,
			["yday"] = 1,
			["isdst"] = false,
		},
		
		profiles = 
		{
			['*'] = 
			{
				lastupdate = 
				{
					["hour"] = 1,
					["min"] = 1,
					["wday"] = 1,
					["day"] = 1,
					["month"] = 1,
					["year"] = 2000,
					["sec"] = 1,
					["yday"] = 1,
					["isdst"] = false,
				},

				wish = 
				{
					[1] = "",
					[2] = "",
					[3] = "",
					[4] = "",
					[5] = ""
				}
			}
		}
	} )
	
GuildWork.RosterData = {}
GuildWork.RosterDataLastUpdate = nil
	
function GuildWork:GetItemWishList(itemName)
	local wishData = {}

	for profile, data in pairs(self.db.char.profiles) do
		for rank, item in ipairs(self.db.char.profiles[profile].wish) do
			if item == itemName then
				wishData[profile] = rank
			end
		end
	end		
	
	return wishData
end

function GuildWork:GetWish(rank)
	return self.db.char.profiles[UnitName("player")].wish[rank]
end

function GuildWork:SetWish(item, rank)
    if item == "\"\"" then
        self.db.char.lastupdate = date("!*t")

		self.db.char.profiles[UnitName("player")].wish[rank] = ""
		self.db.char.profiles[UnitName("player")].lastupdate = date("!*t")
		
		print("Wish", rank, " was removed.")
	else
		name, link, quality, ilevel, reqlevel, itype, isubtype, maxstack, equipslot, texture = GetItemInfo(item)
		
		if link then
			self.db.char.lastupdate = date("!*t")

			self.db.char.profiles[UnitName("player")].wish[rank] = name
			self.db.char.profiles[UnitName("player")].lastupdate = date("!*t")
		else
			print("The item was not found: " .. item)
		end
	end
	
	GuildWork:AnnounceProfile(UnitName("player"))
end

function GuildWork:SetProfileData(profile, lastupdate, wish1, wish2, wish3, wish4, wish5)
	self.db.char.lastupdate = date("!*t")
	
	self.db.char.profiles[profile].lastupdate = lastupdate
	self.db.char.profiles[profile].wish[1] = wish1
	self.db.char.profiles[profile].wish[2] = wish2
	self.db.char.profiles[profile].wish[3] = wish3
	self.db.char.profiles[profile].wish[4] = wish4
	self.db.char.profiles[profile].wish[5] = wish5
end

function GuildWork:GetRoster()

	--[[ Only want to update the rosterData when the roster data information has changed ]]--

	if not GuildWork.RosterDataLastUpdate or time(GuildWork.RosterDataLastUpdate) < time(self.db.char.lastupdate) then
		GuildWork.RosterDataLastUpdate = self.db.char.lastupdate
		
		for profile, data in pairs(self.db.char.profiles) do
			print("Profile: ", profile)
			if(self.db.char.profiles[profile]) then
				GuildWork.RosterData[profile] = {}
				GuildWork.RosterData[profile].wish = {}
				if(not GuildWork.RosterData[profile]) then
					print("NIL")
				end
				GuildWork.RosterData[profile].lastupdate = self.db.char.profiles[profile].lastupdate
				GuildWork.RosterData[profile].wish[1] = self.db.char.profiles[profile].wish[1]
				GuildWork.RosterData[profile].wish[2] = self.db.char.profiles[profile].wish[2]
				GuildWork.RosterData[profile].wish[3] = self.db.char.profiles[profile].wish[3]
				GuildWork.RosterData[profile].wish[4] = self.db.char.profiles[profile].wish[4]
				GuildWork.RosterData[profile].wish[5] = self.db.char.profiles[profile].wish[5]
			end
		end		
	end
		
	return GuildWork.RosterData
end

	